<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/HashMap.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/HashMap.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 13 april 2009, 13:15</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef HASHMAP_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define HASHMAP_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Object.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "Hash.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "Equals.h"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "Util.h"</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include "Array.h"</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;initializer_list&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 SYLPH_BEGIN_NAMESPACE
<a name="l00035"></a>00035 
<a name="l00039"></a>00039 <span class="keyword">template</span>&lt;<span class="keyword">class </span>key_, <span class="keyword">class </span>value_,
<a name="l00040"></a>00040 <span class="keyword">class </span>hash_ = Hash&lt;key_&gt;,
<a name="l00041"></a>00041 <span class="keyword">class </span>equals_ = Equals&lt;key_&gt; &gt;
<a name="l00042"></a><a class="code" href="class_sylph_1_1_hash_map.html">00042</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00043"></a>00043 <span class="keyword">public</span>:
<a name="l00044"></a>00044     <span class="keyword">class </span>Entry;
<a name="l00045"></a>00045 <span class="keyword">public</span>:
<a name="l00046"></a>00046     <span class="keyword">typedef</span> key_ Key;
<a name="l00047"></a>00047     <span class="keyword">typedef</span> value_ Value;
<a name="l00048"></a>00048     <span class="keyword">typedef</span> hash_ HashFunction;
<a name="l00049"></a>00049     <span class="keyword">typedef</span> equals_ EqualsFunction;
<a name="l00050"></a>00050     <span class="keyword">typedef</span> Entry* EntryPtr;
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keyword">struct </span>EntryHelper {
<a name="l00054"></a>00054         Key key;
<a name="l00055"></a>00055         Value&amp; value;
<a name="l00056"></a>00056     };
<a name="l00057"></a>00057 
<a name="l00058"></a>00058     <span class="keyword">class </span>Entry {
<a name="l00059"></a>00059         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a>;
<a name="l00060"></a>00060         <span class="keyword">friend</span> <span class="keyword">class </span>iterator;
<a name="l00061"></a>00061     <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         Entry(Key &amp; _key, Value * _value) : key(_key), value(_value),
<a name="l00064"></a>00064         next(NULL) {
<a name="l00065"></a>00065         }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067         <span class="keyword">virtual</span> ~Entry() {
<a name="l00068"></a>00068             <span class="keyword">delete</span> value;
<a name="l00069"></a>00069         }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071         <span class="keyword">const</span> Key key;
<a name="l00072"></a>00072         Value * value;
<a name="l00073"></a>00073     <span class="keyword">private</span>:
<a name="l00074"></a>00074         Entry * next;
<a name="l00075"></a>00075     };
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keyword">class </span>Pointer : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00078"></a>00078     <span class="keyword">public</span>:
<a name="l00079"></a>00079 
<a name="l00080"></a>00080         Pointer(Key _key, <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a> * _map) :
<a name="l00081"></a>00081         key(_key), map(_map) {
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084         <span class="keyword">inline</span> operator Value*() {
<a name="l00085"></a>00085             <span class="keywordflow">return</span> map-&gt;get(key);
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088         <span class="keyword">inline</span> operator const Value*()<span class="keyword"> const </span>{
<a name="l00089"></a>00089             <span class="keywordflow">return</span> map-&gt;get(key);
<a name="l00090"></a>00090         }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092         <span class="keyword">inline</span> Value&amp; operator*() {
<a name="l00093"></a>00093             <span class="keywordflow">return</span> *map-&gt;get(key);
<a name="l00094"></a>00094         }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="keyword">inline</span> <span class="keyword">const</span> Value&amp; operator*()<span class="keyword"> const </span>{
<a name="l00097"></a>00097             <span class="keywordflow">return</span> *map-&gt;get(key);
<a name="l00098"></a>00098         }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="keyword">inline</span> Value* operator-&gt;() {
<a name="l00101"></a>00101             <span class="keywordflow">return</span> map-&gt;get(key);
<a name="l00102"></a>00102         }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104         <span class="keyword">inline</span> <span class="keyword">const</span> Value* operator-&gt;()<span class="keyword"> const </span>{
<a name="l00105"></a>00105             <span class="keywordflow">return</span> map-&gt;get(key);
<a name="l00106"></a>00106         }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108         <span class="keyword">inline</span> <span class="keywordtype">void</span> operator=(Value&amp; value) {
<a name="l00109"></a>00109             map-&gt;put(key, &amp;value);
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111         <span class="keyword">inline</span> <span class="keywordtype">void</span> operator=(Value value) {
<a name="l00112"></a>00112             map-&gt;put(key, <span class="keyword">new</span> Value(value));
<a name="l00113"></a>00113         }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115         <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> Value&amp; v) {
<a name="l00116"></a>00116             <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>Value*<span class="keyword">&gt;</span> (*this) != NULL &amp;&amp; v != NULL &amp;&amp;
<a name="l00117"></a>00117                     <span class="keyword">static_cast&lt;</span>Value*<span class="keyword">&gt;</span> (*this) == v;
<a name="l00118"></a>00118         }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         <span class="keywordtype">bool</span> operator!=(<span class="keyword">const</span> Value&amp; v) {
<a name="l00121"></a>00121             <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == v);
<a name="l00122"></a>00122         }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124     <span class="keyword">private</span>:
<a name="l00125"></a>00125         Key key;
<a name="l00126"></a>00126         <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a> * map;
<a name="l00127"></a>00127     };
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     <span class="keyword">class </span>iterator : <span class="keyword">public</span> <a class="code" href="class_sylph_1_1_forward_iterator.html" title="Facade used to simplify usage of forward iterators.">ForwardIterator</a>&lt;Entry, iterator&gt; {
<a name="l00130"></a>00130         <span class="keyword">typedef</span> <a class="code" href="class_sylph_1_1_forward_iterator.html">ForwardIterator&lt;Entry, iterator&gt;</a> super;
<a name="l00131"></a>00131     <span class="keyword">public</span>:
<a name="l00132"></a>00132 
<a name="l00133"></a>00133         iterator(<span class="keywordtype">bool</span> begin = <span class="keyword">false</span>,
<a name="l00134"></a>00134                 <a class="code" href="class_sylph_1_1_hash_map.html">HashMap&lt;key_, value_, hash_, equals_&gt;</a>* obj = NULL) : super(begin),
<a name="l00135"></a>00135         map(obj) {
<a name="l00136"></a>00136             <span class="keywordflow">if</span> (begin) {
<a name="l00137"></a>00137                 count = map-&gt;size();
<a name="l00138"></a>00138                 idx = map-&gt;buckets.length;
<a name="l00139"></a>00139                 currentPointer = map-&gt;buckets[idx];
<a name="l00140"></a>00140                 <span class="keywordflow">while</span> (currentPointer == NULL) {
<a name="l00141"></a>00141                     currentPointer = map-&gt;buckets[--idx];
<a name="l00142"></a>00142                 }
<a name="l00143"></a>00143             } <span class="keywordflow">else</span> {
<a name="l00144"></a>00144                 count = 0;
<a name="l00145"></a>00145                 idx = 0;
<a name="l00146"></a>00146                 currentPointer = NULL;
<a name="l00147"></a>00147             }
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150         iterator(<span class="keywordtype">bool</span> begin = <span class="keyword">false</span>,
<a name="l00151"></a>00151                 <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_hash_map.html">HashMap&lt;key_, value_, hash_, equals_&gt;</a>* obj = NULL) :
<a name="l00152"></a>00152         super(begin),
<a name="l00153"></a>00153         map(<span class="keyword">const_cast&lt;</span><a class="code" href="class_sylph_1_1_hash_map.html">HashMap&lt;key_, value_, hash_, equals_&gt;</a>*<span class="keyword">&gt;</span> (obj)) {
<a name="l00154"></a>00154             <span class="keywordflow">if</span> (begin) {
<a name="l00155"></a>00155                 count = map-&gt;size();
<a name="l00156"></a>00156                 idx = map-&gt;buckets.length;
<a name="l00157"></a>00157                 currentPointer = map-&gt;buckets[idx];
<a name="l00158"></a>00158                 <span class="keywordflow">while</span> (currentPointer == NULL) {
<a name="l00159"></a>00159                     currentPointer = map-&gt;buckets[--idx];
<a name="l00160"></a>00160                 }
<a name="l00161"></a>00161             } <span class="keywordflow">else</span> {
<a name="l00162"></a>00162                 count = 0;
<a name="l00163"></a>00163                 idx = 0;
<a name="l00164"></a>00164                 currentPointer = NULL;
<a name="l00165"></a>00165             }
<a name="l00166"></a>00166         }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168         iterator(<span class="keyword">const</span> iterator&amp; other) : map(other.map), count(other.count),
<a name="l00169"></a>00169         idx(other.idx), currentPointer(other.currentPointer) {
<a name="l00170"></a>00170         }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172         <span class="keyword">typename</span> super::reference current()<span class="keyword"> const </span>{
<a name="l00173"></a>00173             <span class="keywordflow">return</span> *currentPointer;
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176         <span class="keywordtype">void</span> next()<span class="keyword"> const </span>{
<a name="l00177"></a>00177             currentPointer = currentPointer-&gt;next;
<a name="l00178"></a>00178             <span class="keywordflow">while</span> (currentPointer == NULL) {
<a name="l00179"></a>00179                 currentPointer = map-&gt;buckets[--idx];
<a name="l00180"></a>00180             }
<a name="l00181"></a>00181         }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183         <span class="keywordtype">bool</span> hasNext()<span class="keyword"> const </span>{
<a name="l00184"></a>00184             <span class="keywordflow">return</span> count &gt; 0;
<a name="l00185"></a>00185         }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="keywordtype">bool</span> equals(<span class="keyword">const</span> iterator&amp; other)<span class="keyword"> const </span>{
<a name="l00188"></a>00188             <span class="keywordflow">return</span> map == other.map &amp;&amp; ((count == other.count &amp;&amp; idx == other.idx
<a name="l00189"></a>00189                     &amp;&amp; currentPointer == other.currentPointer) || (count ==
<a name="l00190"></a>00190                     other.count));
<a name="l00191"></a>00191         }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194     <span class="keyword">private</span>:
<a name="l00195"></a>00195         <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a> * map;
<a name="l00196"></a>00196         <span class="keyword">mutable</span> idx_t count;
<a name="l00197"></a>00197         <span class="keyword">mutable</span> idx_t idx;
<a name="l00198"></a>00198         <span class="keyword">mutable</span> EntryPtr currentPointer;
<a name="l00199"></a>00199     };
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     S_ITERABLE(Entry)
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="keyword">public</span>:
<a name="l00204"></a>00204 
<a name="l00205"></a>00205     <span class="keyword">explicit</span> <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a>(std::size_t initialCapacity = 11, <span class="keywordtype">float</span> _loadFactor = .75f,
<a name="l00206"></a>00206             HashFunction h = Hash&lt;Key&gt;(), EqualsFunction e = <a class="code" href="struct_sylph_1_1_equals.html">Equals&lt;Key&gt;</a>())
<a name="l00207"></a>00207             : loadFactor(_loadFactor), _size(0), buckets(initialCapacity),
<a name="l00208"></a>00208             threshold(initialCapacity*loadFactor), hashf(h), equf(e) {
<a name="l00209"></a>00209     }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_hash_map.html">HashMap&lt;Key, Value, HashFunction, EqualsFunction&gt;</a> &amp; orig)
<a name="l00212"></a>00212             : loadFactor(orig.<a class="code" href="class_sylph_1_1_hash_map.html#71999346fd29befed6702d027c5568c4">loadFactor</a>), _size(orig.<a class="code" href="class_sylph_1_1_hash_map.html#6c038f37ec23dc646008629f4888cf69">_size</a>),
<a name="l00213"></a>00213             buckets(orig.<a class="code" href="class_sylph_1_1_hash_map.html#fe1d7d12802212339653329592c94af3">buckets</a>.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a>), threshold(orig.<a class="code" href="class_sylph_1_1_hash_map.html#6e38c0bd18305bcd59239d698b2991ac">threshold</a>),
<a name="l00214"></a>00214             hashf(orig.<a class="code" href="class_sylph_1_1_hash_map.html#652801f07e1c5c74fa070f3ddefc13bf">hashf</a>), equf(orig.<a class="code" href="class_sylph_1_1_hash_map.html#54d442010cc6beb6bb7f4a489cae8071">equf</a>) {
<a name="l00215"></a>00215         arraycopy(orig.<a class="code" href="class_sylph_1_1_hash_map.html#fe1d7d12802212339653329592c94af3">buckets</a>, 0, buckets, 0, orig.<a class="code" href="class_sylph_1_1_hash_map.html#fe1d7d12802212339653329592c94af3">buckets</a>.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a>);
<a name="l00216"></a>00216     }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a>(<span class="keyword">const</span> std::initializer_list&lt;EntryHelper&gt;&amp; init) : loadFactor(.75f),
<a name="l00219"></a>00219     _size(init.size()), buckets((init.size() &lt;&lt; 1) + 1),
<a name="l00220"></a>00220     threshold(buckets.length*loadFactor), hashf(Hash&lt;Key&gt;()),
<a name="l00221"></a>00221     equf(<a class="code" href="struct_sylph_1_1_equals.html">Equals&lt;Key&gt;</a>()) {
<a name="l00222"></a>00222         <span class="keywordflow">for</span> (EntryHelper* it = init.begin(); it != init.end(); ++it) {
<a name="l00223"></a>00223             put(it-&gt;key, &amp;(it-&gt;value));
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227     <span class="keyword">virtual</span> ~<a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a>() {
<a name="l00228"></a>00228         <span class="comment">/*size_t count = size();</span>
<a name="l00229"></a>00229 <span class="comment">        idx_t idx = buckets.length;</span>
<a name="l00230"></a>00230 <span class="comment">        EntryPtr currentPointer = buckets[idx];</span>
<a name="l00231"></a>00231 <span class="comment">        while (count &gt; 0) {</span>
<a name="l00232"></a>00232 <span class="comment">            while (currentPointer == NULL) {</span>
<a name="l00233"></a>00233 <span class="comment">                currentPointer = buckets[--idx];</span>
<a name="l00234"></a>00234 <span class="comment">            }</span>
<a name="l00235"></a>00235 <span class="comment">            EntryPtr oldPtr = currentPointer;</span>
<a name="l00236"></a>00236 <span class="comment">            currentPointer = currentPointer-&gt;next;</span>
<a name="l00237"></a>00237 <span class="comment">            //delete oldPtr;</span>
<a name="l00238"></a>00238 <span class="comment">        }*/</span>
<a name="l00239"></a>00239     }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241     <span class="keywordtype">void</span> clear() {
<a name="l00242"></a>00242         threshold = loadFactor * 11;
<a name="l00243"></a>00243         _size = 0;
<a name="l00244"></a>00244         buckets.clear();
<a name="l00245"></a>00245 
<a name="l00246"></a>00246     }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248     <span class="keywordtype">bool</span> containsKey(Key key)<span class="keyword"> const </span>{
<a name="l00249"></a>00249         std::idx_t idx = hash(key);
<a name="l00250"></a>00250         EntryPtr entry = buckets[idx];
<a name="l00251"></a>00251         <span class="keywordflow">while</span> (entry != NULL) {
<a name="l00252"></a>00252             <span class="keywordflow">if</span> (equf(key, entry-&gt;key)) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00253"></a>00253             entry = entry-&gt;next;
<a name="l00254"></a>00254         }
<a name="l00255"></a>00255         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="keywordtype">bool</span> containsValue(<span class="keyword">const</span> Value * value)<span class="keyword"> const </span>{
<a name="l00259"></a>00259         <span class="keywordflow">for</span> (std::idx_t i = buckets.length - 1; i &gt;= 0; i--) {
<a name="l00260"></a>00260             EntryPtr entry = buckets[i];
<a name="l00261"></a>00261             <span class="keywordflow">while</span> (entry != NULL) {
<a name="l00262"></a>00262                 <span class="keywordflow">if</span> (equf(value, entry-&gt;value)) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00263"></a>00263                 entry = entry-&gt;next;
<a name="l00264"></a>00264             }
<a name="l00265"></a>00265         }
<a name="l00266"></a>00266         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00267"></a>00267     }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269     std::size_t size()<span class="keyword"> const </span>{
<a name="l00270"></a>00270         <span class="keywordflow">return</span> _size;
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273     Value * <span class="keyword">get</span>(Key key) {
<a name="l00274"></a>00274         <span class="keywordtype">int</span> h = hash(key);
<a name="l00275"></a>00275         std::cout &lt;&lt; <span class="stringliteral">"Key: "</span> &lt;&lt; key &lt;&lt;<span class="stringliteral">": "</span>&lt;&lt;h &lt;&lt; std::endl;
<a name="l00276"></a>00276         EntryPtr entry = buckets[h];
<a name="l00277"></a>00277         <span class="keywordflow">if</span> (entry == NULL) <span class="keywordflow">return</span> NULL;
<a name="l00278"></a>00278         <span class="keywordflow">while</span> (entry-&gt;next != NULL) {
<a name="l00279"></a>00279             <span class="keywordflow">if</span> (entry-&gt;key == key) <span class="keywordflow">return</span> entry-&gt;value;
<a name="l00280"></a>00280             entry = entry-&gt;next;
<a name="l00281"></a>00281         }
<a name="l00282"></a>00282         <span class="keywordflow">return</span> NULL;
<a name="l00283"></a>00283     }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     <span class="keyword">const</span> Value * <span class="keyword">get</span>(Key key) <span class="keyword">const</span> {
<a name="l00286"></a>00286         <span class="keywordtype">int</span> h = hash(key);
<a name="l00287"></a>00287         std::cout &lt;&lt; <span class="stringliteral">"Key: "</span> &lt;&lt; key &lt;&lt;<span class="stringliteral">": "</span>&lt;&lt;h &lt;&lt; std::endl;
<a name="l00288"></a>00288         EntryPtr entry = buckets[h];
<a name="l00289"></a>00289         <span class="keywordflow">if</span> (entry == NULL) <span class="keywordflow">return</span> NULL;
<a name="l00290"></a>00290         <span class="keywordflow">while</span> (entry-&gt;next != NULL) {
<a name="l00291"></a>00291             <span class="keywordflow">if</span> (entry-&gt;key == key) <span class="keywordflow">return</span> entry-&gt;value;
<a name="l00292"></a>00292             entry = entry-&gt;next;
<a name="l00293"></a>00293         }
<a name="l00294"></a>00294         <span class="keywordflow">return</span> NULL;
<a name="l00295"></a>00295     }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297     Pointer operator[](Key key) {
<a name="l00298"></a>00298         <span class="keywordflow">return</span> Pointer(key, <span class="keyword">this</span>);
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301     <span class="keyword">const</span> Pointer operator[](Key key)<span class="keyword"> const </span>{
<a name="l00302"></a>00302         <span class="keywordflow">return</span> Pointer(key, <span class="keyword">this</span>);
<a name="l00303"></a>00303     }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305     <span class="keywordtype">bool</span> empty()<span class="keyword"> const </span>{
<a name="l00306"></a>00306         <span class="keywordflow">return</span> size() == 0;
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309     Value * put(Key key, Value * value) {
<a name="l00310"></a>00310         idx_t idx = hash(key);
<a name="l00311"></a>00311         std::cout &lt;&lt; <span class="stringliteral">"Key: "</span> &lt;&lt; key &lt;&lt;<span class="stringliteral">": "</span>&lt;&lt;idx &lt;&lt; std::endl;
<a name="l00312"></a>00312         EntryPtr entry = buckets[idx];
<a name="l00313"></a>00313 
<a name="l00314"></a>00314         <span class="keywordflow">while</span> (entry != NULL) {
<a name="l00315"></a>00315             <span class="keywordflow">if</span> (equf(key, entry-&gt;key)) {
<a name="l00316"></a>00316                 Value * val = entry-&gt;value;
<a name="l00317"></a>00317                 entry-&gt;value = val;
<a name="l00318"></a>00318                 <span class="keywordflow">return</span> val;
<a name="l00319"></a>00319             } <span class="keywordflow">else</span> {
<a name="l00320"></a>00320                 entry = entry-&gt;next;
<a name="l00321"></a>00321             }
<a name="l00322"></a>00322         }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324         <span class="keywordflow">if</span> (++_size &gt; threshold) {
<a name="l00325"></a>00325             rehash();
<a name="l00326"></a>00326             idx = hash(key);
<a name="l00327"></a>00327         }
<a name="l00328"></a>00328         EntryPtr newEnt = <span class="keyword">new</span> Entry(key, value);
<a name="l00329"></a>00329         newEnt-&gt;next = buckets[idx];
<a name="l00330"></a>00330         buckets[idx] = newEnt;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332         <span class="keywordflow">return</span> NULL;
<a name="l00333"></a>00333     }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335     <span class="keywordtype">void</span> putAll(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_hash_map.html">HashMap&lt;Key, Value, HashFunction, EqualsFunction&gt;</a>&amp; map) {
<a name="l00336"></a>00336 
<a name="l00337"></a>00337         <span class="keywordflow">for</span> (iterator it = map.<a class="code" href="class_sylph_1_1_hash_map.html#3996c7c7265d2300b69e326ed0ad01a5">begin</a>(); it != map.<a class="code" href="class_sylph_1_1_hash_map.html#f5bc180337cf62251cd4a29b381d5ddc">end</a>(); ++it) {
<a name="l00338"></a>00338             this-&gt;put((*it)-&gt;key, (*it)-&gt;value);
<a name="l00339"></a>00339         }
<a name="l00340"></a>00340     }
<a name="l00341"></a>00341 
<a name="l00342"></a>00342     Value * <span class="keyword">remove</span>(Key key) {
<a name="l00343"></a>00343         std::idx_t idx = hash(key);
<a name="l00344"></a>00344         EntryPtr entry = buckets[idx];
<a name="l00345"></a>00345         EntryPtr last = NULL;
<a name="l00346"></a>00346 
<a name="l00347"></a>00347         <span class="keywordflow">while</span> (entry != NULL) {
<a name="l00348"></a>00348             <span class="keywordflow">if</span> (equf(key, entry-&gt;key)) {
<a name="l00349"></a>00349                 <span class="keywordflow">if</span> (last == NULL) {
<a name="l00350"></a>00350                     buckets[idx] = entry-&gt;next;
<a name="l00351"></a>00351                 } <span class="keywordflow">else</span> {
<a name="l00352"></a>00352 
<a name="l00353"></a>00353                     last-&gt;next = entry-&gt;next;
<a name="l00354"></a>00354                 }
<a name="l00355"></a>00355                 _size--;
<a name="l00356"></a>00356                 <span class="keywordflow">return</span> entry-&gt;value;
<a name="l00357"></a>00357             }
<a name="l00358"></a>00358             last = entry;
<a name="l00359"></a>00359             entry = entry-&gt;next;
<a name="l00360"></a>00360         }
<a name="l00361"></a>00361         <span class="keywordflow">return</span> NULL;
<a name="l00362"></a>00362     }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364     <a class="code" href="class_sylph_1_1_hash_map.html">HashMap</a> &amp; operator&lt;&lt;(<span class="keyword">const</span> EntryHelper&amp; eh) {
<a name="l00365"></a>00365         put(eh.key, &amp;(eh.value));
<a name="l00366"></a>00366         <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00367"></a>00367     }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="keyword">private</span>:
<a name="l00370"></a>00370     <span class="keywordtype">float</span> loadFactor;
<a name="l00371"></a>00371     std::size_t _size;
<a name="l00372"></a>00372     <a class="code" href="class_sylph_1_1_array.html">Array&lt;EntryPtr&gt;</a> buckets;
<a name="l00373"></a>00373     std::size_t threshold;
<a name="l00374"></a>00374     HashFunction hashf;
<a name="l00375"></a>00375     EqualsFunction equf;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377     sint hash(<span class="keyword">const</span> Key&amp; key)<span class="keyword"> const </span>{
<a name="l00378"></a>00378         <span class="keywordflow">return</span> abs(hashf(key) % buckets.length);
<a name="l00379"></a>00379     }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381     <span class="keywordtype">void</span> rehash() {
<a name="l00382"></a>00382         <a class="code" href="class_sylph_1_1_array.html">Array&lt;EntryPtr&gt;</a> oldBuckets = buckets;
<a name="l00383"></a>00383 
<a name="l00384"></a>00384         <span class="keywordtype">int</span> newcapacity = (buckets.length * 2) + 1;
<a name="l00385"></a>00385         threshold = (int) (newcapacity * loadFactor);
<a name="l00386"></a>00386         buckets = <a class="code" href="class_sylph_1_1_array.html">Array&lt;EntryPtr &gt;</a> (newcapacity);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388         <span class="keywordflow">for</span> (idx_t i = oldBuckets.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a> - 1; i &gt;= 0; i--) {
<a name="l00389"></a>00389             EntryPtr entry = oldBuckets[i];
<a name="l00390"></a>00390             <span class="keywordflow">while</span> (entry != NULL) {
<a name="l00391"></a>00391                 idx_t idx = hash(entry-&gt;key);
<a name="l00392"></a>00392                 EntryPtr next = entry-&gt;next;
<a name="l00393"></a>00393                 entry-&gt;next = buckets[idx];
<a name="l00394"></a>00394                 buckets[idx] = entry;
<a name="l00395"></a>00395                 entry = next;
<a name="l00396"></a>00396             }
<a name="l00397"></a>00397         }
<a name="l00398"></a>00398     }
<a name="l00399"></a>00399 };
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 SYLPH_END_NAMESPACE
<a name="l00402"></a>00402 <span class="preprocessor">#endif  </span><span class="comment">/* HASHMAP_H_ */</span>
<a name="l00403"></a>00403 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
